# Class PUSH

java.lang.Object
org.apache.bcel.generic.PUSH

All Implemented Interfaces:
  `CompoundInstruction, InstructionConstants, VariableLengthInstruction`

public final class PUSH extends Object implements CompoundInstruction, VariableLengthInstruction, InstructionConstants
Wrapper class for push operations, which are implemented either as BIPUSH, LDC or xCONST_n instructions.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface InstructionConstants

  `InstructionConstants.Clinit`

- ## Field Summary

  ### Fields inherited from interface InstructionConstants

  `AALOAD, AASTORE, ACONST_NULL, ALOAD_0, ALOAD_1, ALOAD_2, ARETURN, ARRAYLENGTH, ASTORE_0, ASTORE_1, ASTORE_2, ATHROW, BALOAD, BASTORE, bla, CALOAD, CASTORE, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DMUL, DNEG, DREM, DRETURN, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FMUL, FNEG, FREM, FRETURN, FSUB, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, ILOAD_0, ILOAD_1, ILOAD_2, IMUL, INEG, INSTRUCTIONS, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE_0, ISTORE_1, ISTORE_2, ISUB, IUSHR, IXOR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDIV, LMUL, LNEG, LOR, LREM, LRETURN, LSHL, LSHR, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, NOP, POP, POP2, RETURN, SALOAD, SASTORE, SWAP, THIS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PUSH(ConstantPoolGen cp, boolean value)`
  `PUSH(ConstantPoolGen cp, double value)`
  `PUSH(ConstantPoolGen cp, float value)`
  `PUSH(ConstantPoolGen cp, int value)`
  This constructor also applies for values of type short, char, byte
  `PUSH(ConstantPoolGen cp, long value)`
  `PUSH(ConstantPoolGen cp, Boolean value)`
  `PUSH(ConstantPoolGen cp, Character value)`
  creates a push object from a Character value.
  `PUSH(ConstantPoolGen cp, Number value)`
  `PUSH(ConstantPoolGen cp, String value)`
  `PUSH(ConstantPoolGen cp, ArrayType value)`
  Pushes an array type constant, for example `int[].class`, `String[].class`, and so on.
  `PUSH(ConstantPoolGen cp, ObjectType value)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Instruction`
  `getInstruction()`
  `InstructionList`
  `getInstructionList()`
  Gets the instruction list.
  `String`
  `toString()`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### PUSH

    public PUSH(ConstantPoolGen cp, ArrayType value)
    Pushes an array type constant, for example `int[].class`, `String[].class`, and so on.
    Parameters:
      `cp` - generated constant pool.
      `value` - to push.
    Since:
      6.7.0

  - ### PUSH

    public PUSH(ConstantPoolGen cp, boolean value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, Boolean value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, Character value)
    creates a push object from a Character value. Warning: Make sure not to attempt to allow autoboxing to create this value parameter, as an alternative constructor will be called
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, double value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, float value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, int value)
    This constructor also applies for values of type short, char, byte
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, long value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, Number value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

  - ### PUSH

    public PUSH(ConstantPoolGen cp, ObjectType value)
    Parameters:
      `cp` - The constant pool.
      `value` - to push.
    Since:
      6.0

  - ### PUSH

    public PUSH(ConstantPoolGen cp, String value)
    Parameters:
      `cp` - Constant pool.
      `value` - to push.

- ## Method Details

  - ### getInstruction

    public Instruction getInstruction()

  - ### getInstructionList

    public InstructionList getInstructionList()
    Description copied from interface: `CompoundInstruction`
    Gets the instruction list.
    Specified by:
      `getInstructionList` in interface `CompoundInstruction`
    Returns:
      the instruction list.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`
    Returns:
      mnemonic for instruction.